/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Wed Jul  9 22:58:01 2003 by Jeff Dalton
 * Copyright: (c) 2003, AIAI, University of Edinburgh
 */

package ix.icore.plan;

import java.util.*;

import ix.util.Name;

public abstract class AbstractRefinement extends PlanObject {

    protected Name id;
    protected Name expands;
    // Could have "protected List planVariableDeclarations"
    // here, but it would change where it appears as a subelement
    // in automatically generated syntax descriptions.  /\/

    public AbstractRefinement() {
    }

    public Name getId() {
        return id;
    }

    public void setId(Name id) {
        this.id = id;
    }

    public Name getExpands() {
        return expands;
    }

    public void setExpands(Name expands) {
        this.expands = expands;
    }

    public abstract List getSubitems();

    public abstract void setSubitems(List subitems);

}
