/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Fri May 21 01:22:39 2004 by Jeff Dalton
 * Copyright: (c) 2004, AIAI, University of Edinburgh
 */

package ix.iplan;

import ix.util.lisp.Symbol;

/**
 * Symbols used for various purposes when planning web-service
 * compositions.
 */
public interface ServiceSymbols {

    /** Refinement annotation key. */
    public static Symbol
	S_INPUT_OBJECTS = Symbol.intern("input-objects"),
	S_OUTPUT_OBJECTS = Symbol.intern("output-objects"),
	S_OWL_S_PROCESS = Symbol.intern("owl-s-process");

    /** Domain annotation key. */
    public static Symbol
	S_NAME_MAP = Symbol.intern("name-map");

    /** Activity annotation key. */
    public static Symbol
	S_INPUTS = Symbol.intern("inputs"),
	S_OUTPUTS = Symbol.intern("outputs");

    public static Symbol S_TYPE = Symbol.intern("type");

}
