/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Mon Jun 16 01:35:33 2008 by Jeff Dalton
 * Copyright: (c) 2008, AIAI, University of Edinburgh
 */

package ix.util.reflect;

import java.lang.annotation.*;

/**
 * Annotation for listing fields that should be treated as having
 * a different name in the the visible syntax for a class.
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Inherited
@Documented
public @interface AliasFields {

    String[] value();

}
